<template>
  <div>
    <div v-if="!load && expandCategory === null && !searchArr.length" class="wrap q-pa-md q-gutter-sm">
      <div v-for="(category, index) in category_lr" :key="category.id_clr">
        <div class="expand p-2" :class="{'active':expandCategory === index}" v-show="category.id_parent === 0">
          <router-link
            :to="{name: 'Category', params: {id: category.id_clr}}"
            @click.prevent="save(category, category.name_clr, 'Category', {id: category.id_clr})"
            class="flex"
          >
            <p class="count mr-4 opacity-70">{{category.id_clr}}</p>
            <img src="../assets/images/icons/folder.png" width="20" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_clr">{{category.name_clr}}</p>
            <img @click.prevent="category_lrEdit(category)"
                 src="../assets/images/icons/pencil-outline.svg"
                 width="16"
                 class="ml-auto mr-4"
                 alt=""
            >
          </router-link>
        </div>
      </div>
    </div>
    <div v-else-if="isSearch">
      <router-link to="/" @click.prevent="clearSearch">
        <q-btn flat icon="arrow_left" label="Назад" />
      </router-link>
      <div class="text-center my-6 text-xl opacity-70">Найдено исследований: <span class="text-white px-4 py-1 bg-black rounded-md text-ls">{{searchArr.length}}</span></div>
      <div v-for="(category, index) in searchArr" :key="category.id_clr">
        <div v-if="category" class="expand p-2">
          <router-link
            :to="{name: 'ResearchOption', params: {id: category.id_clr, id_clr: category.id_clr, id_lr: category.id_lr}}"
            @click="save(category, category.name_lr, 'ResearchOption', {id: category.id_clr, id_clr: category.id_clr, id_lr: category.id_lr})"
            class="flex">
            <p class="count mr-4">{{category.id_lr}}</p>
            <img src="../assets/images/icons/lab.png" width="16" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_lr">{{category.name_lr}}</p>
            <img
                 src="../assets/images/icons/pencil-outline.svg"
                 width="16"
                 class="ml-auto mr-4"
                 alt=""
                 v-if="1===2"
            >
          </router-link>
        </div>
      </div>
    </div>
    <div v-if="load" class="flex justify-center mt-16">
      <LoadsSpinner v-if="load" large/>
    </div>
    <Modal v-if="modalEdit" @close="modalEdit = false" class="text-white">
      <template #body>
        <div class="text-lg opacity-70 mb-4">Редактирование</div>
        <q-input autofocus standout v-model="editCategoryObj.name_clr" label="Название" class="text-white" />
        <div class="flex mt-4 justify-end">
          <q-btn color="red" label="Удалить" class="mr-2" />
          <q-btn color="primary" label="Применить" />
        </div>
      </template>
    </Modal>
  </div>
</template>

<script>
import {ref, onMounted, computed} from 'vue'
import axios from 'axios'
import Modal from "../components/Modal.vue";
import LoadsSpinner from "../components/Loads-spinner.vue";
import {useStore} from "vuex";
export default {
  components: {LoadsSpinner, Modal},
  setup () {
    let store = useStore()
    let category_lr = ref([])
    let editCategoryObj = ref({})
    let editLaboratoryResearch = ref({})
    let selectedCategory = ref([])
    let LaboratoryResearch = ref([])
    let load = ref(false)
    let modalEdit = ref(false)
    let modalEditLaboratoryResearch = ref(false)
    let expandCategory = ref(null)

    async function getcategory_lr () {
      load.value = true
      await axios.get('http://188.120.231.191:3000/category_lr').then(res => {
        category_lr.value = res.data
        load.value = false
      })
    }
    function category_lrEdit (el) {
      editCategoryObj.value = el
      modalEdit.value = true
    }
    function laboratoryResearchEdit (el) {
      editLaboratoryResearch.value = el
      modalEditLaboratoryResearch.value = true
    }
    async function selectCategory (index) {
      await axios.get('http://188.120.231.191:3000/category_lr?id_parent=eq.' + category_lr.value[index].id_clr).then(res => selectedCategory.value = res.data)
      if (expandCategory.value === index) expandCategory.value = null
      else expandCategory.value = index
    }
    async function selectSubCategory (index) {
      await axios.get('http://188.120.231.191:3000/LaboratoryResearch?id_clr=eq.' + selectedCategory.value[index].id_clr)
          .then(res => LaboratoryResearch.value = res.data)
    }
    function save (el, name, path, params) {
      localStorage.setItem('index', JSON.stringify(el))
      store.commit('SET_PATH', {name, index: 0, path, params })
      if (searchArr.value.length) {
        store.commit('SET_STATE_SEARCH')
      }
    }
    function clearSearch () {
      store.commit('SEARCH_CLEAR')
    }

    let searchArr = computed(function () {
      return store.state.searchArray
    });
    let isSearch = computed(function () {
      return store.state.isSearch
    });
    onMounted(()=> {
      getcategory_lr()
    })
    return {
      category_lr,
      LaboratoryResearch,
      modalEdit,
      modalEditLaboratoryResearch,
      expandCategory,
      editCategoryObj,
      editLaboratoryResearch,
      selectedCategory,
      load,
      store,
      searchArr,
      isSearch,
      category_lrEdit,
      clearSearch,
      laboratoryResearchEdit,
      selectCategory,
      selectSubCategory,
      save
    }
  }
}
</script>

<style lang="scss">
// Анимация VUE
.category-enter {
  opacity: 0;
}
.category-enter-active {
  //transform: translateX(650px);
  transition: all .4s ease-in-out;
}
.v-transition-sidebar-enter-to {
  transform: translateX(0px);
  opacity: 1;
}
.category-leave {
  opacity: 1;
}
.category-leave-active {
  opacity: 0;
  transition: all .4s ease;
}
.category-leave-to {
  //transform: translateX(350px);
}
.category-move {
  transition: transform .4s;
}
</style>
